import jp.jig.jiglet.*;

public class Clock extends Jiglet {
	//  0
	// 1 2
	//  3
	// 4 5
	//  6
	int[][] segmentFlag = new int[][] {
		{1, 1, 1, 0, 1, 1, 1},		//0
		{0, 0, 1, 0, 0, 1, 0},		//1
		{1, 0, 1, 1, 1, 0, 1},		//2
		{1, 0, 1, 1, 0, 1, 1},		//3
		{0, 1, 1, 1, 0, 1, 0},		//4
		{1, 1, 0, 1, 0, 1, 1},		//5
		{1, 1, 0, 1, 1, 1, 1},		//6
		{1, 1, 1, 0, 0, 1, 0},		//7
		{1, 1, 1, 1, 1, 1, 1},		//8
		{1, 1, 1, 1, 0, 1, 1},		//9
	};
	
	Image base11, base12;
	Image base21, base22;
	static final int SIZE_TIME = 20;
	static final int SIZE_DATE = 14;
	
	
	public void main() {
		base11 = getImage("base11.gif");
		base12 = getImage("base12.gif");
		base21 = getImage("base21.gif");
		base22 = getImage("base22.gif");
		
		clearKey();
		setSoftLabel("I");
		for (;;) {
			int key = getKey();
			repaint();
			sleep(200);
			
			if (key == KEY_SOFT) {
				terminate();
			}
			
			if (getLaunchType() != LAUNCHED_AS_CONCIERGE) {
				if (key == KEY_IAPP) {
					terminate();
				}
			} else {
				if (key == KEY_IAPP) {
					setState(STATE_JIGLET, JIGLET_DEACTIVE);
				}
				if (getState(STATE_SHOULD_SLEEP) == SHOULD_SLEEP_YES) {
					setState(STATE_JIGLET, JIGLET_SLEEP);
				}
			}
		}
	}
	
	int[] timeArray = new int[6];
	public void paint(boolean allDrawFlag) {
		setTime(currentTime());
		setColor(0, 0, 0);
		fillRect(0, 0, DW, DH);
		if (base11 == null) {
			return;
		}
		
		//t̕`
		int year = getTime(CALENDAR_YEAR) % 100;
		int month = getTime(CALENDAR_MONTH) + 1;
		int date = getTime(CALENDAR_DAY_OF_MONTH);
		timeArray[0] = year / 10;
		timeArray[1] = year % 10;
		timeArray[2] = month / 10;
		timeArray[3] = month % 10;
		timeArray[4] = date / 10;
		timeArray[5] = date % 10;
		
		int x = 20;
		int y = DH / 2 - SIZE_TIME - SIZE_DATE - 20;
		
		setColor(255, 0, 0);
		for (int i = 0; i < 6; i++) {
			drawNumber(timeArray[i], x, y, SIZE_DATE);
			x += SIZE_DATE + 8;
			if (i % 2 == 1 && i < 5) {
				int sx1 = x + 3;
				int sy1 = y;
				int sx2 = x + SIZE_DATE / 2 + 2;//6;
				int sy2 = y + SIZE_DATE * 2 + 10;
				drawLine(sx1, sy2, sx2, sy1);
				drawLine(sx1 + 1, sy2, sx2 + 1, sy1);
				x += SIZE_DATE / 2 + 10;
			}
		}
		
		//̕`
		int hour = getTime(CALENDAR_HOUR_OF_DAY);
		int min = getTime(CALENDAR_MINUTE);
		int sec = getTime(CALENDAR_SECOND);
		
		timeArray[0] = hour / 10;
		timeArray[1] = hour % 10;
		timeArray[2] = min / 10;
		timeArray[3] = min % 10;
		timeArray[4] = sec / 10;
		timeArray[5] = sec % 10;
		
		x = (DW - (SIZE_TIME + 8) * 6 - 20) / 2;
		y = (DH - SIZE_DATE) / 2;
		setColor(255, 0, 0);
		for (int i = 0; i < 6; i++) {
			drawNumber(timeArray[i], x, y, SIZE_TIME);
			x += SIZE_TIME + 8;
			if (i % 2 == 1 && i < 5) {
				x += 2;
				fillRect(x, y + SIZE_TIME / 2 + 5, 5, 5);
				fillRect(x, y + SIZE_TIME / 2 + SIZE_TIME + 5, 5, 5);
				x += 8;
			}
		}
	}
	void drawNumber(int num, int x, int y, int size) {
		int[] flag = segmentFlag[num];
		for (int j = 0; j < 7; j++) {
			if (flag[j] > 0) {
				int bx = 0;
				int by = 0;
				int v = 0;
				switch (j) {
					case 0: {
						bx = 3;
						by = 0;
						v = 1;
						break;
					}
					case 1: {
						bx = 0;
						by = 4;
						break;
					}
					case 2: {
						bx = size + 2;
						by = 4;
						break;
					}
					case 3: {
						bx = 3;
						by = size + 3;
						v = 1;
						break;
					}
					case 4: {
						bx = 0;
						by = size + 7;
						break;
					}
					case 5: {
						bx = size + 2;
						by = size + 7;
						break;
					}
					case 6: {
						bx = 3;
						by = size * 2 + 6;
						v = 1;
						break;
					}
				}
				if (size == SIZE_TIME) {
					if (v == 0) {
						drawImage(base11, bx + x, by + y);
					} else {
						drawImage(base12, bx + x, by + y);
					}
				} else {
					if (v == 0) {
						drawImage(base21, bx + x, by + y);
					} else {
						drawImage(base22, bx + x, by + y);
					}
				}
			}
		}
	}
}
